Request

Response

    Scope-Specific Bid Forms
    GET

    scope-specific-bid-forms

    Retrieves a list of the scope-specific bid forms created by the user’s company.

    The term “scope-specific” is displayed in the BuildingConnected applications and refers specifically to a given bid package; for example, the “Concrete” bid package may have its own scope-specific bid form.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/construction/buildingconnected/v2/scope-specific-bid-forms
    Authentication Context
    User context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    * Required

    Request

    Query String Parameters

    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    limit
    int
    The maximum number of records that the endpoint may return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last page of a set is returned.

    Default value: 100

    filter[projectId]
    array: string
    Comma separated IDs of projects with which the objects returned in the response must be associated.
    filter[currentAccLinkedProjectId]
    string
    The ID of a Forma project with which the objects returned in the response are associated with BuildingConnected projects that are linked to this Forma Project.
    filter[bidPackageId]
    string
    The ID of a bid package with which the objects returned in the response must be associated.
    filter[updatedAt]
    string
    The required range of dates and times during which the last update must have been made to the objects returned in the response, in ISO 8601 format.

    A single date and time takes this format: YYYY-MM-DDThh:mm:ss.SSSZ, A date and time range takes this format: YYYY-MM-DDThh:mm:ss.SSSZ..YYYY-MM-DDThh:mm:ss.SSSZ. Range queries can be closed or open in either direction: YYYY-MM-DDThh:mm:ss.SSSZ.. or ..YYYY-MM-DDThh:mm:ss.SSSZ.

    includeSectionHeaders
    boolean
    If true, include section headers as standalone line items
    includeExternal
    boolean
    Include bid forms of projects from external companies in the response. Possible values:
    • true: External project bid forms are included.
    • false: (Default) External project bid forms are not included.

    Note that this parameter can be used only with filter[projectId], filter[currentAccLinkedProjectId], or filter[bidPackageId].

    Response

    HTTP Status Code Summary

    200
    OK
    OK
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    Information about the returned scope-specific bid forms that were created by the current user’s company.
    id
    string
    The ID of the scope-specific bid form.

    Max length: 24

    projectId
    string
    The ID of the project that the bid form addresses.

    Max length: 24

    currentAccLinkedProjectId
    string
    The ID of an ACC project linked with this bid form’s project.
    bidPackageId
    string
    The ID of the bid package that the bid form addresses.

    Max length: 24

    createdBy
    string
    The ID of the user who created the scope-specific bid form.

    Max length: 24

    updatedBy
    string
    The ID of the user who last updated the scope-specific bid form.

    Max length: 24

    createdAt
    datetime: ISO 8601
    The date and time that the scope-specific form was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time that the scope-specific form was last updated, in ISO 8601 format.
    isTemplate
    boolean
    Indicates whether this bid form a is a template or an actual scope-specific bid form for a project.
    • true: This bid form is a template.
    • false: This bid form belongs to an actual project.
    lineItems
    object
    A paginated list of the bid form’s line items.

    Max 100 line items per page.

    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    The array of bid form line items
    id
    string
    The unique ID of the scope-specific line item.

    Max length: 24

    type
    enum:string
    The type of the scope-specific line item.

    The possible values have the following UI equivalents:

    • ADDENDUM — Scope-Specific Information and Unit Costs
    • ALTERNATE — Alternates
    • COST_BREAKDOWN — Line Items
    • INCLUSION — Inclusions
    • SCOPE_CLARIFICATION — Scope-Specific Clarifications
    description
    string
    A description of the scope-specific line item.
    section
    string
    The section that the scope-specific line item is under. This value is null if the item is not under a section.
    isRequired
    boolean
    Indicates whether the scope-specific line item is required. Possible values:
    • true: The scope-specific line item is required.
    • false: The scope-specific line item is optional.
    unit
    enum:string
    The unit format of the scope-specific line item.

    The possible values of this field depend on the value of type. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • ADDENDUM — TEXT, YES_NO, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, TOTAL_COST_ONLY
    • ALTERNATE — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • BONDING — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • CERTIFICATION — TEXT, YES_NO
    • COST_BREAKDOWN — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • DISCLAIMER — Converted to null
    • INCLUSION — YES_NO_WITH_ADJUSTMENT
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY
    • SCOPE_CLARIFICATION — Converted to null

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    The cost code associated with the scope-specific line item.
    quantity
    number
    The quantity of the scope-specific line item. This value is null under either of the following conditions:
    • The value of type is not COST_BREAKDOWN. Only COST_BREAKDOWN type items have a quantity.
    • The value of unit is TOTAL_COST_ONLY. Items with a TOTAL_COST_ONLY unit do not have a quantity.
    isQuantityFixed
    boolean
    Indicates whether the scope-specific line item quantity is fixed. If it is fixed, bidders cannot change it. Possible values:
    • true: The scope-specific line item quantity is fixed.
    • false: The scope-specific line item quantity can be changed by bidders.
    external
    object
    Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.

    Note that BuildingConnected does not use information in this object.

    id
    string
    The ID of the external tool.
    name
    string
    The name of the external tool.

    Example

    OK

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/scope-specific-bid-forms?filter[currentAccLinkedProjectId]=00f1b796-293a-4c1e-9474-f09711011426&filter[updatedAt]=2020-05-01T06:00:00.000Z..' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": 100,
        "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
        "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
      },
      "results": [
        {
          "id": "5af0892518d349f6d59e1bbb",
          "projectId": "59d2bd7440b36a0da258f24d",
          "currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
          "bidPackageId": "590dd127b359f408f190b5a7",
          "createdBy": "5542856b27aae240452fce62",
          "updatedBy": "5542856b27aae240452fce62",
          "createdAt": "2021-08-19T23:07:16.083Z",
          "updatedAt": "2021-08-20T23:07:16.083Z",
          "isTemplate": false,
          "lineItems": {
            "pagination": {
              "limit": 100,
              "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
              "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
            },
            "results": [
              {
                "id": "53811754d3a604966df72247",
                "type": "COST_BREAKDOWN",
                "description": "Duct Insulation",
                "section": "Furnish & Install",
                "isRequired": true,
                "unit": "HOURS",
                "code": "D2",
                "quantity": 1000,
                "isQuantityFixed": true,
                "external": {
                  "id": "ext-cost-id-123",
                  "name": "External Cost Code"
                }
              }
            ]
          }
        }
      ]
    }
    
    Show More